<?php
ob_start(); // needed to avoid "Cannot modify header information - headers already"
/**
 * Script to read xlm osm data and parse them in a csv format
 *
 */

// Check to see if all the required parameters are given *************************************************************************
if (!isset($_GET["output"]) || !isset($_GET["cat"]) || !isset($_GET["filename"]) || !isset($_GET["lang"]) || !isset($_GET["land"])) {die("Error, Not all parameters supplied");}

// parameters

$output = $_GET["output"];
$filename = $_GET["filename"];
$cat = $_GET["cat"];
$cat1 = explode(":",$cat);
$cat = $cat1[1];
$lang = $_GET["lang"]; 
$country = $_GET["land"];
$country = $country . ".xml";


// Test for selction group *******************************************************************************************************

switch ($cat) 
      {
      case "amenity":
      $block = array('fuel', 'parking', 'atm', 'ferry_terminal', 'aerodrome', 'station', 'pharmacy', 'hospital', 'veterinary', 'place_of_worship', 'bank');
           break;
      case "shop":
      $block = array('fast_food', 'restaurante', 'bar', 'cafe' , 'pub', 'supermarket', 'convenience', 'mall', 'seafood', 'bakery', 'butcher');
           break;
      case "tourism":
      $block = array('camp_site', 'caravan_site', 'chalet', 'guest_house', 'hostel', 'hotel', 'motel', 'museum', 'picnic_site', 'theme_park', 'zoo', 'archaeological_site', 'castle', 'ruins');
           break;
      default:
      $block = array($cat);
   }

// Test for selction group *******************************************************************************************************


// Translate category *************************************************************************************************************

switch ($lang) 
      {
      case "en":
           include('include/en.php'); // allow to translate string for cat
           break;
      case "es":
           include('include/es.php'); // allow to translate string for cat
           break;
      case "fr":
           include('include/fr.php'); // allow to translate string for cat
           break;
   }


// read data and parse *************************************************************************************************************

if(file_exists($country)) {
$date = date("d-m-Y", filemtime($country));
$xml = new XMLReader(); 
$xml->open($country); // input file as source
while($xml->read()){ 
  switch ($xml->nodeType){ 
   case XMLReader::ELEMENT: 

    if($xml->hasAttributes){
    switch ($xml->name){
       case "node": // read attributes only for "node" nodes
       $lat = $xml->getattribute("lat");
       $lon = $xml->getattribute("lon");
       $comut = "no"; // reset comut at each node
                  
       case "tag": // read attributes only for "tag" nodes
       $k = $xml->getattribute("k");
       $v = $xml->getattribute("v");
       
       foreach ($block as $cat) {
       if ($v == $cat):
       $namcat = strReplaceAssoc($messages,$v);
       $readline = '"' . "\n" . $lon . ',' . $lat . ',"' . $namcat; //write lon lat & text
       $result = $result . $readline; //write line & text
       $comut = "yes"; // allow to read and write name only for $cat
       endif;
       
       if ($k == "name" && $comut == "yes"): // add "name" text only for $cat when exists.
       $nampoi = $v;
       $readline = " " . $nampoi; //write lon lat & text
       $result = $result . $readline; //write additional text
       $comut = "no"; // reset comut at each node
       endif;
       } //close while
       } //close switch
       }

} //close switch
} //close while
$result = ltrim($result,'"'); //clean the first line of the string
$result = ltrim($result,"\n"); //clean the first line of the string
$result = str_replace("&apos;", "' ", $result);
$result = str_replace("&quot;", "-", $result);
$xml->close();
} else {
exit (strReplaceAssoc($messages,'Data for this country not available'));
}


// Choose Output format ************************************************************************************************************

switch($output) {
  case "csv":
  $filename = $filename . ".csv";
  //HEADER (Allow to download data to user pc)
  header("Pragma: public");
  header("Expires: 0");
  header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
  header("Cache-Control: public");
  header("Content-Description: File Transfer");
  header("Content-Disposition: attachment; filename=$filename");
  header("Content-Type: application/force-download; charset=utf-8");
  $result = $result . '"'; // close the csv file
  echo $result;
  break;
  
  case "csv2": 
  $filename = $filename . ".csv";
  //HEADER (Allow to download data to user pc)
  header("Pragma: public");
  header("Expires: 0");
  header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
  header("Cache-Control: public");
  header("Content-Description: File Transfer");
  header("Content-Disposition: attachment; filename=$filename");
  header("Content-Type: application/force-download; charset=utf-8");
  $result = $result . '"'; // close the csv file
  $result = str_replace(",", ";", $result);
  $out = str_replace(".", ",", $result);
  echo $out;
  break;
  
  
  case "ov2":
  $filename = $filename . ".ov2";
  //HEADER (Allow to download data to user pc)
  header("Pragma: public");
  header("Expires: 0");
  header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
  header("Cache-Control: public");
  header("Content-Description: File Transfer");
  header("Content-Disposition: attachment; filename=$filename");
  //header("Content-Type: application/octet-stream");
  header("Content-Transfer-Encoding: binary; charset=utf-8");
  header("Content-Type: application/force-download; charset=utf-8");
  $result = str_replace('"', '', $result);
  $readline = explode("\n", $result); //create array separate by new line
  for ($i=0;$i<count($readline);$i++)
  {
  $line = explode(",",$readline[$i]);
  $newline = chr(0x02) .  pack("V",strlen($line[2]) + 14) . pack("V",round($line[0] * 100000))  . pack("V",round($line[1] * 100000))  . $line[2] . chr(0x00);
  $out = $out . $newline;
  }
  echo $out;
  break;
    
  case "gpx":
   $filename = $filename . ".gpx";
  //HEADER (Allow to download data to user pc)
  header("Pragma: public");
  header("Expires: 0");
  header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
  header("Cache-Control: public");
  header("Content-Description: File Transfer");
  header("Content-Disposition: attachment; filename=$filename");
  header("Content-Type: application/force-download; charset=utf-8");

  echo "<?xml version='1.0' encoding='UTF-8'?>\n" .
       "<gpx version=\"1.1\" creator=\"Bluemarmot POI-Export\" xmlns=\"http://www.topografix.com/GPX/1/1\"\n" .
       "  xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n" .
       "  xsi:schemaLocation=\"http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd\">\n" .
       "<metadata></metadata>\n";
  $result = str_replace('"', '', $result);
  $readline = explode("\n", $result); //create array separate by new line
  for ($i=0;$i<count($readline);$i++)
  {
  $line = explode(",",$readline[$i]);
  $newline = '<wpt lat="' . $line[1] . '" lon="' . $line[0] . '">' . "\n" . '  <name>' . $line[2] . '</name>' . "\n" . '</wpt>';
  $out = $out . "\n" . $newline;
  }
  $out = $out . "\n" . "</gpx>"; // close the gpx file
  $out = ltrim($out,"\n"); //clean the first line of the string
  echo $out;
  break;
  
  case "kml":
   $filename = $filename . ".kml";
  //HEADER (Allow to download data to user pc)
  header("Pragma: public");
  header("Expires: 0");
  header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
  header("Cache-Control: public");

  header("Content-Description: File Transfer");
  header("Content-Disposition: attachment; filename=$filename");
  header("Content-Type: application/force-download; charset=utf-8");

  echo "<?xml version='1.0' encoding='UTF-8'?>\n<kml xmlns='http://earth.google.com/kml/2.2'>\n";
  echo "<Document>\n";
  $result = str_replace('"', '', $result);
  $readline = explode("\n", $result); //create array separate by new line
  for ($i=0;$i<count($readline);$i++)
  {
  $line = explode(",",$readline[$i]);
  $newline = "<Placemark>\n\t<name>" . $line[2] . "</name>\n" . "\t<Point>\n\t\t<coordinates>" . $line[0] . ", " . $line[1] . "</coordinates>\n\t</Point>\n</Placemark>";
  $out = $out . "\n" . $newline;
  }
  $out = $out . "\n" . "</Document>"; // close the document section
  $out = $out . "\n" . "</kml>"; // close the kml file
  $out = ltrim($out,"\n"); //clean the first line of the string
  echo $out;
  break;
    
  default:
    die("No valid output specified: $output");
}


// function to translate (replace string) ***************************************************************************************
function strReplaceAssoc(array $replace, $subject) { 
return str_replace(array_keys($replace), array_values($replace), $subject);
} 
ob_end_flush(); // needed to avoid "Cannot modify header information - headers already"
?>